// LOOPZ(PC98) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*8*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i;

	//	FMȃf[^
	struct fpos ma[] =
	{
		{ 0x64, 0x05, 0x0000, 0x08ca },	// CARTOON
		{ 0x64, 0x08, 0x0000, 0x0be5 },	// OLD FILM
		{ 0x65, 0x03, 0x0000, 0x0a66 },	// DEAD SPACE
		{ 0x65, 0x06, 0x0000, 0x0ebe },	// FUTUROLOGY
		{ 0x66, 0x02, 0x0000, 0x0ec4 },	// PERSIAN CARPET
		{ 0x66, 0x06, 0x0000, 0x09a9 },	// OPPEKE SONG
//		{ 0x8e, 0x01, 0x009f, 0x00b8 },	// t~pf[^
		{ 0x8e, 0x01, 0x0157, 0x0139 },	// LOOP COMPLETE
		{ 0x8e, 0x01, 0x0291, 0x00e2 },	// GAMEOVER
		{ 0x8e, 0x01, 0x0373, 0x012b },	// FANFARE
// ȉDOSANZX\ȕ
/*
		{ 0x94, 0x02, 0x0000, 0x08ca },	// CARTOON
		{ 0x94, 0x05, 0x0000, 0x0be5 },	// OLD FILM
		{ 0x94, 0x08, 0x0000, 0x0a66 },	// DEAD SPACE
		{ 0x95, 0x03, 0x0000, 0x0ebe },	// FUTUROLOGY
		{ 0x95, 0x07, 0x0000, 0x0ec4 },	// PERSIAN CARPET
		{ 0x96, 0x03, 0x0000, 0x09a9 },	// OPPEKE SONG
*/
		{ 0x00, 0x00, 0x0000, 0x0000 },
	};
	//	BEEPpȃf[^
	struct fpos mb[] =
	{
		{ 0x67, 0x03, 0x0000, 0x02b6 },	// CARTOON
		{ 0x67, 0x04, 0x0000, 0x02b6 },	// OLD FILM
		{ 0x67, 0x05, 0x0000, 0x034e },	// DEAD SPACE
		{ 0x67, 0x06, 0x0000, 0x034e },	// FUTUROLOGY
		{ 0x67, 0x07, 0x0000, 0x03ec },	// PERSIAN CARPET
		{ 0x67, 0x08, 0x0000, 0x03ba },	// OPPEKE SONG
		{ 0x8e, 0x01, 0x049f, 0x001a },	// LOOP COMPLETE
		{ 0x8e, 0x01, 0x04b9, 0x0026 },	// GAMEOVER
		{ 0x8e, 0x01, 0x04df, 0x0038 },	// FANFARE
// ȉDOSANZX\ȕ
/* 
		{ 0x96, 0x06, 0x0000, 0x02b6 },	// CARTOON
		{ 0x96, 0x07, 0x0000, 0x02b6 },	// OLD FILM
		{ 0x96, 0x08, 0x0000, 0x034e },	// DEAD SPACE
		{ 0x97, 0x01, 0x0000, 0x0216 },	// FUTUROLOGY
		{ 0x97, 0x02, 0x0000, 0x03ec },	// PERSIAN CARPET
		{ 0x97, 0x03, 0x0000, 0x023c },	// OPPEKE SONG
*/
// ȉ͌ʉ
		{ 0x8e, 0x01, 0x0517, 0x000a },	// ʉ#1
		{ 0x8e, 0x01, 0x0521, 0x0008 },	// ʉ#2
		{ 0x8e, 0x01, 0x0529, 0x0014 },	// ʉ#3
		{ 0x8e, 0x01, 0x053d, 0x0008 },	// ʉ#4
		{ 0x8e, 0x01, 0x0545, 0x0014 },	// ʉ#5
		{ 0x8e, 0x01, 0x0559, 0x000a },	// ʉ#6
		{ 0x00, 0x00, 0x0000, 0x0000 },
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x08);
	// hCo؂o
	fcut("DRIVER", 0x8d, 0x46, 0x01, 0x08, 0x03, 0x0340, 0x58c0);
	// ȃf[^؂o
	for (i=0; ma[i].sec; i++)
	{
		sprintf(fname,"MA%03d",i);
		fcut(fname, ma[i].trk, ma[i].trk>>1, ma[i].trk&1, ma[i].sec, 0x03, ma[i].ofs, ma[i].size);
	}
	for (i=0; mb[i].sec; i++)
	{
		sprintf(fname,"MB%03d",i);
		fcut(fname, mb[i].trk, mb[i].trk>>1, mb[i].trk&1, mb[i].sec, 0x03, mb[i].ofs, mb[i].size);
	}
	return 0;
}

